
package uoc.facturaweb.controlador;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uoc.facturaweb.modelo.Concepto;
import uoc.facturaweb.modelo.Entidad;
import uoc.facturaweb.modelo.Factura;
import uoc.facturaweb.modelo.Manejodb;
/**
 *
 * @author Juanjo
 */
@WebServlet(name = "AnnadirConcepto", urlPatterns = {"/AnnadirConcepto"})
public class AnnadirConcepto extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        String des=request.getParameter("des");
        des=des.substring(1, des.length()-1);
        String uni=request.getParameter("uni");
        uni=uni.substring(1, uni.length()-1);
        String cant=request.getParameter("cant");
        double canti=Double.parseDouble(cant);
        String preci=request.getParameter("precio");
        double precio=Double.parseDouble(preci);
        double piva=Double.parseDouble(request.getParameter("piva"));        
        double impo=Double.parseDouble(request.getParameter("impo")); 
        double iva=Double.parseDouble(request.getParameter("iva"));
        double impotot=Double.parseDouble(request.getParameter("impotot"));
        int idFactura=0;
        Concepto c= new Concepto(idFactura,des,canti, precio,uni,piva);
        c.Guardar();
        Manejodb mj = new Manejodb();
        ArrayList<Entidad> lc=mj.Obtener("CONCEPTO", idFactura);
        Factura f=new Factura();
        f.conceptos= new ArrayList<Concepto>();
        try {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<table border='1'>");
            for (Entidad e:lc){
                Concepto co= (Concepto) e;
                out.println("<tr>");
                out.println("<td>"+co.descripcion+"</td>");
                out.println("<td>"+co.cantidad+"</td>"); 
                out.println("<td>"+co.unidades+"</td>"); 
                out.println("<td>"+co.precio+"</td>"); 
                out.println("<td>"+co.importeBruto()+"</td>");
                out.println("<td>"+co.porcentaje+"% </td>"); 
                out.println("<td>"+co.iva()+"</td>"); 
                out.println("<td>"+co.importeTotal()+"</td>"); 
                out.println("</tr>");
                f.conceptos.add(co);
            }
            out.println("<tr>");
            out.println("<td>Total Sin IVA</td>");
            out.println("<td>"+f.importeBruto()+"</td>"); 
            out.println("<td>IVA</td>"); 
            out.println("<td>"+f.ivaTotal()+"</td>"); 
            out.println("<td>TOTAL FACTURA</td>");
            out.println("<td>"+f.importeTotal()+"</td>"); 
            out.println("</tr>");            
            out.println("</table>");
        } finally {
            out.close();
            mj.cerrar();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
