
package uoc.facturaweb.controlador;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import javax.activation.MimetypesFileTypeMap;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Part;
/**
 *
 * @author Juanjo
 */
@WebServlet(name = "Descargar", urlPatterns = {"/Descargar"})
public class Descargar extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String rutar= new File (".").getAbsolutePath ();
        rutar=rutar.substring(0, rutar.length()-1)+"FacturasGeneradas\\";
        String nombre=request.getParameter("urlfirma");
        //
        //DESCARGAR FICHERO QUE ESTA EN LA RUTA rutar+nombre
        File fileToDownload = new File(rutar+"\\"+nombre);
         FileInputStream fileInputStream = new FileInputStream(fileToDownload);
         ServletOutputStream out2 = response.getOutputStream();   
         String mimeType =  new MimetypesFileTypeMap().getContentType(rutar+"\\"+nombre); 
         response.setContentType(mimeType); 
         response.setContentLength(fileInputStream.available());
         response.setHeader( "Content-Disposition", "attachment; filename=\""
           + fileToDownload.getName() + "\"" );
         int c;
         while((c=fileInputStream.read()) != -1){
          out2.write(c);
         }
         out2.flush();
         out2.close();
         fileInputStream.close();  
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    
           public String getFileName(Part part) {
            String contentHeader = part.getHeader("content-disposition");
            String[] subHeaders = contentHeader.split(";");
            for(String current : subHeaders) {
                if(current.trim().startsWith("filename")) {
                    int pos = current.indexOf('=');
                    String fileName = current.substring(pos+1);
                    return fileName.replace("\"", "");
                }
            }
            return null;
        }
    
}
