
package uoc.facturaweb.controlador;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uoc.facturaweb.modelo.Manejodb;
import uoc.facturaweb.modelo.Usuario;
/**
 *
 * @author Juanjo
 */
@WebServlet(name = "MiInfo", urlPatterns = {"/MiInfo"})
public class MiInfo extends HttpServlet {
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String nombre=request.getParameter("nombre");
        int idUsuario= (Integer) request.getSession().getAttribute("idUsuario");
        String scope= (String) request.getSession().getAttribute("scope");
        String residencia=request.getParameter("residencia");
        String persona=request.getParameter("persona");
        String apellido1=request.getParameter("apellido1");
        String apellido2=request.getParameter("apellido2");
        String idFiscal=request.getParameter("idfiscal");
        String direccion=request.getParameter("direccion");
        String pobl=request.getParameter("poblacion");
        String cPostal=request.getParameter("cpostal");
        String prov=request.getParameter("provincia");
        String pais=request.getParameter("pais");
        Usuario u;
        if (persona.equals("F")){
            //La persona es fisica
            u=new Usuario(persona,residencia,idFiscal,null,null,nombre,apellido1,apellido2, direccion,cPostal,pobl,prov,pais, idUsuario);
        }else{
            //la persona es juridica.
            u= new Usuario(persona,residencia,idFiscal,nombre, apellido1, null, null , null, direccion,cPostal,pobl,prov,pais, idUsuario);
        }
        u.idFirma=scope;
        u.Actualizar();
        PrintWriter out = response.getWriter();
        try {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet MiInfo</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet MiInfo at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
