
package uoc.facturaweb.modelo;

/**
 *
 * @author Juanjo
 */
public class Concepto extends Entidad{
    public int idFactura;
    public String descripcion;
    public double cantidad;
    public double precio;
    public String unidades;
    public double porcentaje;

    public Concepto() {
    }
    
    public double importeBruto(){
        return cantidad*precio;
    } 
    public double iva(){
        return importeBruto()*porcentaje/100;
    }
    public double importeTotal(){
        return importeBruto()+iva();
    }
    
    public Concepto(int id) {
        super(id);
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public double getCantidad() {
        return cantidad;
    }

    public Concepto(int idFactura,String descripcion, double cantidad, double precio, String unidades, double porcentaje, int id) {
        super(id);
        this.descripcion = descripcion;
        this.cantidad = cantidad;
        this.precio = precio;
        this.unidades = unidades;
        this.porcentaje = porcentaje;
        this.idFactura=idFactura;
    }
    public Concepto(int idFactura,String descripcion, double cantidad, double precio, String unidades, double porcentaje) {
        this.descripcion = descripcion;
        this.cantidad = cantidad;
        this.precio = precio;
        this.unidades = unidades;
        this.porcentaje = porcentaje;
        this.idFactura=idFactura;
    }
    public void setCantidad(double cantidad) {
        this.cantidad = cantidad;
    }

    public double getPrecio() {
        return precio;
    }

    public void setPrecio(double precio) {
        this.precio = precio;
    }

    public String getUnidades() {
        return unidades;
    }

    public void setUnidades(String unidades) {
        this.unidades = unidades;
    }

    public double getPorcentaje() {
        return porcentaje;
    }

    public void setPorcentaje(double porcentaje) {
        this.porcentaje = porcentaje;
    }

    public int getIdFactura() {
        return idFactura;
    }

    public void setIdFactura(int idFactura) {
        this.idFactura = idFactura;
    }

}
