
package uoc.facturaweb.modelo;

import uoc.facturaweb.modelo.Usuario;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Juanjo
 */
public class Manejodb {
    
     Conexion_1 c;

    public Manejodb() {
        this.c = new Conexion_1();
    }
  
     public void cerrar(){
          this.c.cerrar();
      }
     
    public Cliente ObtenerCliente(int idCliente){
        Cliente cli=new Cliente();
          try { 
            String SQL ="SELECT * FROM CLIENTE WHERE IDCLIENTE="+idCliente;
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
            int idusu = 0, idcli = 0;
            String a = null,b = null,bb = null,d = null,e = null,f = null,g = null,h = null,j = null,k = null,l = null,m = null,n = null;
            while (RS.next()){
                idusu=RS.getInt("IDUSUARIO");
                idcli=RS.getInt("IDCLIENTE");
                a=RS.getString("TIPOPERSONA");
                b=RS.getString("TIPORESIDENCIA");
                bb=RS.getString("IDFISCAL");
                d=RS.getString("RAZONSOCIAL");
                e=RS.getString("NOMBRECOMERCIAL");
                f=RS.getString("NOMBRE");
                g=RS.getString("APELLIDO1");
                h=RS.getString("APELLIDO2");
                j=RS.getString("DIRECCION");
                k=RS.getString("CODPOSTAL");
                l=RS.getString("POBLACION");
                m=RS.getString("PROVINCIA");
                n=RS.getString("PAIS");
            }
            cli.idUsuario=idusu;
            cli.id=idcli;
            cli.tipoPersona=a;
            cli.tipoResidencia=b;
            cli.idFiscal=bb;
            cli.razonSocial=d;
            cli.nombreComercial=e;
            cli.nombre=f;
            cli.apellido1=g;
            cli.apellido2=h;
            cli.direccion=j;
            cli.codPostal=k;
            cli.poblacion=l;
            cli.provincia=m;
            cli.pais=n;
               
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return cli;
      }
    
 public Usuario ObtenerUsuario(int idUsuario){
        Usuario cli=new Usuario();
          try { 
            String SQL ="SELECT * FROM USUARIO WHERE IDUSUARIO="+idUsuario;
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
            int idusu = 0, idcli = 0;
            String a = null,b = null,bb = null,d = null,e = null,f = null,g = null,h = null,j = null,k = null,l = null,m = null,n = null,AN=null;
            while (RS.next()){
                idusu=RS.getInt("IDUSUARIO");
                AN=RS.getString("ID");
                a=RS.getString("TIPOPERSONA");
                b=RS.getString("TIPORESIDENCIA");
                bb=RS.getString("IDFISCAL");
                d=RS.getString("RAZONSOCIAL");
                e=RS.getString("NOMBRECOMERCIAL");
                f=RS.getString("NOMBRE");
                g=RS.getString("APELLIDO1");
                h=RS.getString("APELLIDO2");
                j=RS.getString("DIRECCION");
                k=RS.getString("CODPOSTAL");
                l=RS.getString("POBLACION");
                m=RS.getString("PROVINCIA");
                n=RS.getString("PAIS");
            }
            cli.idFirma=AN;
            cli.id=idusu;
            cli.tipoPersona=a;
            cli.tipoResidencia=b;
            cli.idFiscal=bb;
            cli.razonSocial=d;
            cli.nombreComercial=e;
            cli.nombre=f;
            cli.apellido1=g;
            cli.apellido2=h;
            cli.direccion=j;
            cli.codPostal=k;
            cli.poblacion=l;
            cli.provincia=m;
            cli.pais=n;
               
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return cli;
      }
 
 public Factura ObtenerFactura(int idFactura){
        Factura fac=new Factura();
          try { 
            String SQL ="SELECT * FROM FACTURA WHERE IDFACTURA="+idFactura;
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
                int idusu = 0, emitida = 0, recep = 0;
                String fech = null, numero = null, docid = null,url = null;
           while (RS.next()){
                 
                idusu=RS.getInt("IDEMISOR");                
                recep=RS.getInt("IDRECEPTOR");
                numero=RS.getString("NUMERO");
                emitida=RS.getInt("EMITIDA");
                fech=RS.getString("FECHA");
                docid=RS.getString("DOCUMENTID");
                url=RS.getString("URLFIRMA");
            }
           fac.emitida=emitida;
           Date d=null;
           d=new SimpleDateFormat("yyyy-MM-dd").parse(fech);                    
           fac.fecha=d;
            fac.id=idFactura;
            fac.idEmisor=idusu;
            fac.idReceptor=recep;
            fac.numero=numero;
            fac.conceptos=Conceptos(idFactura);
            fac.urlfirma=url;
            fac.documentId=docid;
               
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParseException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return fac;
      }
 
 public Usuario ObtenerUsuario(String idUsuario){
        Usuario cli=new Usuario();
          try { 
            String SQL ="SELECT * FROM USUARIO WHERE IDFIRMA='"+idUsuario+"'";
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
            int idusu = 0, idcli = 0;
            String a = null,b = null,bb = null,d = null,e = null,f = null,g = null,h = null,j = null,k = null,l = null,m = null,n = null,AN=null;
            while (RS.next()){
                idusu=RS.getInt("IDUSUARIO");
                AN=RS.getString("ID");
                a=RS.getString("TIPOPERSONA");
                b=RS.getString("TIPORESIDENCIA");
                bb=RS.getString("IDFISCAL");
                d=RS.getString("RAZONSOCIAL");
                e=RS.getString("NOMBRECOMERCIAL");
                f=RS.getString("NOMBRE");
                g=RS.getString("APELLIDO1");
                h=RS.getString("APELLIDO2");
                j=RS.getString("DIRECCION");
                k=RS.getString("CODPOSTAL");
                l=RS.getString("POBLACION");
                m=RS.getString("PROVINCIA");
                n=RS.getString("PAIS");
            }
            cli.idFirma=AN;
            cli.id=idusu;
            cli.tipoPersona=a;
            cli.tipoResidencia=b;
            cli.idFiscal=bb;
            cli.razonSocial=d;
            cli.nombreComercial=e;
            cli.nombre=f;
            cli.apellido1=g;
            cli.apellido2=h;
            cli.direccion=j;
            cli.codPostal=k;
            cli.poblacion=l;
            cli.provincia=m;
            cli.pais=n;
               
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return cli;
      }

   public ArrayList<Entidad> Obtener(String nTabla, int id){
        ArrayList<Entidad> Lista=new ArrayList<Entidad>();
 try { 
     String SQL=null;
     if (nTabla.equals("FACTURA")){
            SQL ="SELECT ID"+nTabla+" FROM "+nTabla+" WHERE IDEMISOR="+id;
     }
     if (nTabla.equals("CLIENTE") || nTabla.equals("FACTURARECIBIDA")){
             SQL ="SELECT ID"+nTabla+" FROM "+nTabla+" WHERE IDUSUARIO="+id;
     }
     if (nTabla.equals("CONCEPTO")){
             SQL ="SELECT ID"+nTabla+" FROM "+nTabla+" WHERE IDFACTURA="+id;
     }
      ResultSet RS;
        if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
            Statement s =c.c.createStatement();

            RS = s.executeQuery(SQL);
        }else{
            RS=c.consulta2(SQL);
        }
        int idfac = 0;
        while (RS.next()){
           // IDCONCEPTO INT PRIMARY KEY AUTO_INCREMENT, IDFACTURA INT, DESCRIPCION VARCHAR(100), CANTIDAD DOUBLE, PRECIO DOUBLE, UNIDADES VARCHAR(30), PORCENTAJE DOUBLE
            idfac=RS.getInt("ID"+nTabla);
            if (nTabla.equals("CLIENTE")){
                Lista.add(this.ObtenerCliente(idfac));
            }
            if (nTabla.equals("FACTURA")){
                Lista.add(this.ObtenerFactura(idfac));
            } 
            if (nTabla.equals("CONCEPTO")){
                Lista.add(this.ObtenerConcepto(idfac));
            }
            if (nTabla.equals("FACTURARECIBIDA")){
                Lista.add(this.ObtenerFRecibida(idfac));
            }
        }            
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
        return Lista;
    } 

    public Concepto ObtenerConcepto(int idConcepto){
        Concepto concept= new Concepto();
          try { 
            String SQL ="SELECT * FROM CONCEPTO WHERE IDCONCEPTO="+idConcepto;
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
            int idfac = 0;
            String AN=null, uni=null;
            Double can = null,pre = null, por = null;
            while (RS.next()){
               // IDCONCEPTO INT PRIMARY KEY AUTO_INCREMENT, IDFACTURA INT, DESCRIPCION VARCHAR(100), CANTIDAD DOUBLE, PRECIO DOUBLE, UNIDADES VARCHAR(30), PORCENTAJE DOUBLE
                idfac=RS.getInt("IDFACTURA");
                AN=RS.getString("DESCRIPCION");
                can=RS.getDouble("CANTIDAD");
                pre=RS.getDouble("PRECIO");
                uni=RS.getString("UNIDADES");
                por=RS.getDouble("PORCENTAJE");
            }
            concept.id=idConcepto;
            concept.descripcion=AN;
            concept.idFactura=idfac;
            concept.cantidad=can;
            concept.porcentaje=por;
            concept.precio=pre;
            concept.unidades=uni;   
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return concept;
      }
    
     public void actualizarConceptos(int idFactura){
        try {
            String SQL= "UPDATE CONCEPTO SET IDFACTURA ="+idFactura+" WHERE IDFACTURA=0 ";
            ResultSet RS;
            if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                Statement s =c.c.createStatement();
                s.execute(SQL);
            }else{
                RS=c.consulta2(SQL);
            }
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
     }
 
      public void actualizarFactura(Factura f){
        try {
            String SQL= "UPDATE FACTURA SET DOCUMENTID ='"+f.documentId+"', URLFIRMA='"+f.urlfirma+"' WHERE IDFACTURA="+f.id;
            ResultSet RS;
            if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                Statement s =c.c.createStatement();
                s.execute(SQL);
            }else{
                RS=c.consulta2(SQL);
            }
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
         
     }    
     
    private ArrayList<Concepto> Conceptos(int idFactura) {
        ArrayList<Concepto> lc=new ArrayList<Concepto>();
    try { 
            String SQL ="SELECT IDCONCEPTO FROM CONCEPTO WHERE IDFactura="+idFactura;
             ResultSet RS;
                if (!c.c.isClosed()){//Al ser recursivo para que no se cierre el Result SEt se crea
                    Statement s =c.c.createStatement();
                    RS = s.executeQuery(SQL);
                }else{
                    RS=c.consulta2(SQL);
                }
            int idfac = 0;
            while (RS.next()){
               // IDCONCEPTO INT PRIMARY KEY AUTO_INCREMENT, IDFACTURA INT, DESCRIPCION VARCHAR(100), CANTIDAD DOUBLE, PRECIO DOUBLE, UNIDADES VARCHAR(30), PORCENTAJE DOUBLE
                idfac=RS.getInt("IDCONCEPTO");
                lc.add(this.ObtenerConcepto(idfac));   
            }            
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }
           return lc;
    }
    
private FacturaRecibida ObtenerFRecibida(int idfac) {
        FacturaRecibida FR = new FacturaRecibida();  
        try {
            String SQL ="SELECT IDUSUARIO, EMISOR, FECHA, RUTA FROM FACTURARECIBIDA WHERE IDFACTURARECIBIDA="+idfac;
              c.consulta(SQL);
              ResultSet RS=c.getS().getResultSet();
              while (RS.next()){                 
                  String emi=RS.getString("EMISOR");
                  String fech=RS.getString("FECHA");
                  String ruta=RS.getString("RUTA");
                  int usu=RS.getInt("IDUSUARIO");
                  FR.emisor=emi;
                  FR.ruta=ruta;
                  FR.idUsuario=usu;
                  Date d=null;
                  d=new SimpleDateFormat("yyyy-MM-dd").parse(fech);                    
                  FR.fecha=d;
              }
        } catch (SQLException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParseException ex) {
            Logger.getLogger(Manejodb.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
        }
        return FR;
    }
}
