
package uoc.facturaweb.trustedx;

import gvjava.org.json.JSONArray;
import gvjava.org.json.JSONException;
import gvjava.org.json.JSONObject;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

/**
 *
 * @author Juanjo
 */
public class InforCertificado {

    public InforCertificado() {
    }
    
    public static ArrayList<String> infoCertificado(String token){
        ArrayList<String> info=new ArrayList<String>();
        try {            
            OkHttpClient client = new OkHttpClient();
            Request request2 = new Request.Builder()
                    .url("https://uoc.safelayer.com:8082/trustedx-resources/esigp/v1/sign_identities")
                    .get()
                    .addHeader("Authorization", "Bearer "+token)
                    .addHeader("cache-control", "no-cache")
                    .addHeader("Postman-Token", "d8a28e55-5668-4aa2-bd4f-498fa51629c5")
                    .build();
            Response response2 = client.newCall(request2).execute();
            String jsondata2=response2.body().string();//recuperar llamada
            JSONObject Jobject = null;
            Jobject = new JSONObject(jsondata2);
            JSONArray pendi=Jobject.getJSONArray("sign_identities");
            JSONObject pend=pendi.getJSONObject(0);
            info.add(pend.getString("id"));
            info.add(pend.getString("description"));
            info.add(pend.getString("type"));
            info.add(pend.getString("domain"));
            JSONArray jsondata3=pend.getJSONArray("labels");
            info.add(jsondata3.get(0).toString());
            info.add(jsondata3.get(1).toString());
            info.add(jsondata3.get(2).toString());
        } catch (IOException ex) {
            Logger.getLogger(InforCertificado.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JSONException ex) {
            Logger.getLogger(InforCertificado.class.getName()).log(Level.SEVERE, null, ex);
        }
        return info;
    }
    
}
