/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package uoc.facturaweb.trustedx;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

/**
 *
 * @author Juanjo
 */
@WebServlet(name = "XMLFirmado", urlPatterns = {"/XMLFirmado"})
public class XMLFirmado extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String ide = (String) request.getSession().getAttribute("idFacturault");
        String token = (String) request.getSession().getAttribute("tokenFirma");
        OkHttpClient client = new OkHttpClient();

        Request request2 = new Request.Builder()
          .url("https://uoc.safelayer.com:8082/trustedx-resources/esignsp/v2/documents/"+ide+"/content")
          .get()
          .addHeader("Authorization", "Bearer "+token)
          .addHeader("cache-control", "no-cache")
          .addHeader("Postman-Token", "cbabe966-a390-4f8e-bb77-5f331d5c953f")
          .build();

        Response response2 = client.newCall(request2).execute();        
        String idprocess= request.getParameter("signer_process_id");
        OkHttpClient client3 = new OkHttpClient();
        Request request3 = new Request.Builder()
          .url("https://uoc.safelayer.com:8082/trustedx-resources/esignsp/v2/signer_processes/"+idprocess)
          .delete(null)
          .addHeader("Authorization", "Bearer "+token)
          .addHeader("cache-control", "no-cache")
          .addHeader("Postman-Token", "0f4c0b86-3d76-42a4-90b0-d8e2cdf3d01d")
          .build();
        Response response3 = client3.newCall(request3).execute();
        try (PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet XMLFirmado</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet XMLFirmado at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        }
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
