
package uoc.facturaweb.controlador;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import javax.servlet.ServletException;
import javax.servlet.annotation.MultipartConfig;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Part;
import static uoc.facturaweb.trustedx.BorraCertificado.borrarCertificado;
import static uoc.facturaweb.trustedx.InforCertificado.infoCertificado;
import static uoc.facturaweb.trustedx.SubeCertificado.SubirCertif;

/**
 *
 * @author Juanjo
 */
@WebServlet(name = "SubirCertificado", urlPatterns = {"/SubirCertificado"})
@MultipartConfig(location="/")
public class SubirCertificado extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        Collection<Part> parts = request.getParts();
        String rutar= new File (".").getAbsolutePath ();
        rutar=rutar.substring(0, rutar.length()-1)+"Certificados\\";
        String nombreFichero="";
        for(Part part : parts) {
                part.write(rutar+getFileName(part));                   
                nombreFichero=part.getSubmittedFileName(); 
        }
        String cadena, cadena2 = "";
        java.io.FileReader fa=new FileReader(rutar+"/"+nombreFichero);
        BufferedReader b = new BufferedReader(fa);
        byte [] xm = null;
        while((cadena = b.readLine())!=null) {
            xm=cadena.getBytes();
            cadena2=cadena2+cadena;
        }  
        
        String token =request.getAttribute(cadena).toString();    
        ArrayList<String> inf=infoCertificado(token);
        if (inf.size()>0){
            borrarCertificado(inf.get(0), token);
        }
        SubirCertif(xm,token);try (PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Certificado subido:</title>");            
            out.println("</head>");
            out.println("<body>");
            
            out.println("<p><a href='index.jsp' >Volver</a></p>");
            out.println("</body>");
            out.println("</html>");
        }
    }
        public String getFileName(Part part) {
            String contentHeader = part.getHeader("content-disposition");
            String[] subHeaders = contentHeader.split(";");
            for(String current : subHeaders) {
                if(current.trim().startsWith("filename")) {
                    int pos = current.indexOf('=');
                    String fileName = current.substring(pos+1);
                    return fileName.replace("\"", "");
                }
            }
            return null;
        }
    

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
