
package uoc.facturaweb.modelo;

import java.lang.reflect.Field;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Juanjo
 */
public class Entidad {
    public int id;
    
    public void Guardar(){
        String nombre=this.getClass().getName();
        nombre=nombre.substring(nombre.indexOf(".")+1);
        String cadena="INSERT INTO "+ nombre+ " (";
        Field[] lf=this.getClass().getDeclaredFields();
        String bb=lf[0].getName();
        for (int i=0; i< lf.length; i++){
            if(lf[i].getType().getName()!="java.util.ArrayList"){
                cadena=cadena+lf[i].getName()+", ";}
        }
        cadena=cadena.substring(0, cadena.length()-2);
        cadena=cadena+") VALUES ('";
        
        for (int i=0; i< lf.length; i++){
            try {
                if(lf[i].getType().getName()!="java.util.ArrayList"){//si no es ArrayList
                    if (lf[i].getType().getName()!="java.util.Date"){//si no es Fecha
                        cadena=cadena+lf[i].get(this)+"', '";
                    }else{//si es Fecha lo transformamos a formato Mysql
                        java.util.Date f=(java.util.Date) lf[i].get(this);
                        java.sql.Date fech=new java.sql.Date(f.getTime());
                        cadena=cadena+fech+"', '";
                    }
                }
            } catch (IllegalArgumentException ex) {
                Logger.getLogger(Entidad.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IllegalAccessException ex) {
                Logger.getLogger(Entidad.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        cadena=cadena.substring(0, cadena.length()-4);
        cadena=cadena+"')";        
        Conexion_1 c=new Conexion_1();
        c.consulta(cadena);
        c.cerrar();
   
    }
    public int GuardarId(){
        String nombre=this.getClass().getName();
        nombre=nombre.substring(nombre.indexOf(".")+1);
        String cadena="INSERT INTO "+ nombre+ " (";
        Field[] lf=this.getClass().getDeclaredFields();
        String name=this.getClass().getCanonicalName();
        String bb=lf[0].getName();
        for (int i=0; i< lf.length; i++){
            if(lf[i].getType().getName()!="java.util.ArrayList"){
                cadena=cadena+lf[i].getName()+", ";}
        }
        cadena=cadena.substring(0, cadena.length()-2);
        cadena=cadena+") VALUES ('";
        
        for (int i=0; i< lf.length; i++){
            try {
                if(lf[i].getType().getName()!="java.util.ArrayList"){//si no es ArrayList
                    if (lf[i].getType().getName()!="java.util.Date"){//si no es Fecha
                        cadena=cadena+lf[i].get(this)+"', '";
                    }else{//si es Fecha lo transformamos a formato Mysql
                        java.util.Date f=(java.util.Date) lf[i].get(this);
                        java.sql.Date fech=new java.sql.Date(f.getTime());
                        cadena=cadena+fech+"', '";
                    }
                }
            } catch (IllegalArgumentException ex) {
                Logger.getLogger(Entidad.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IllegalAccessException ex) {
                Logger.getLogger(Entidad.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//java.util.ArrayList
        cadena=cadena.substring(0, cadena.length()-4);
        cadena=cadena+"')";        
        Conexion_1 c=new Conexion_1();
        c.consulta(cadena);
        String SQL="SELECT MAX(ID"+nombre+") AS ID FROM "+nombre;        
        int identificador=0;
        try {
            c.consulta(SQL);  
            ResultSet RS;
            RS = c.getS().getResultSet();
            RS.next();
            identificador=RS.getInt("ID");
        } catch (SQLException ex) {
            Logger.getLogger(Entidad.class.getName()).log(Level.SEVERE, null, ex);
        }
        c.cerrar();
        this.setId(identificador);
        return identificador;
   
    }
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Entidad(int id) {
        this.id = id;
    }
    public Entidad() {
        
    }
}
