
package uoc.facturaweb.trustedx;

import gvjava.org.json.JSONException;
import gvjava.org.json.JSONObject;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import uoc.facturaweb.modelo.Manejodb;
import uoc.facturaweb.modelo.Usuario;

/**
 *
 * @author Juanjo
 */
@WebServlet(name = "ObtenerToken", urlPatterns = {"/ObtenerToken"})
public class ObtenerToken extends HttpServlet {
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
       String code= "nose";
        code=request.getParameter("code");
        //aplicar los certificados
        System.setProperty("javax.net.ssl.keyStore", "C:\\Users\\Juanjo\\.keystore");            
        System.setProperty("javax.net.ssl.keyStorePassword", "admin");
        System.setProperty("javax.net.ssl.keyStoreType", "JKS");
        System.setProperty("javax.net.ssl.trustStore", "C:\\Users\\Juanjo\\.keystore");
        System.setProperty("javax.net.ssl.trustStorePassword", "admin");
        System.setProperty("javax.net.ssl.trustStoreType", "JKS");
        //Crear euquest
        OkHttpClient client = new OkHttpClient();
        MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
        RequestBody body = RequestBody.create(mediaType, "grant_type=authorization_code&code="+code+"&redirect_uri=http%3A%2F%2Flocalhost%3A8080%2Ffacturaweb%2FObtenerToken");
        Request request2 = new Request.Builder()
            .url("https://uoc.safelayer.com:8082/trustedx-authserver/oauth/main/token")
            .post(body)
            .addHeader("Authorization", "Basic ZmFjdHVyYWU6ZmFjdHVyYWU=")
            .addHeader("Content-Type", "application/x-www-form-urlencoded")
            .addHeader("cache-control", "no-cache")
            .build();
        // lanzar llamada
        Response response2 = client.newCall(request2).execute();
        String jsondata=response2.body().string();//recuperar llamada
        String token=null;
        try {
                JSONObject Jobject = null;                 
                Jobject = new JSONObject(jsondata);
                token=Jobject.getString("access_token");
                String scope=Jobject.getString("scope");
                Manejodb mj= new Manejodb();
                Usuario u= mj.ObtenerUsuario(scope);
                if (u==null){
                    u=new Usuario(); 
                    u.Guardar();
                }
                u.idFirma=scope;
                u.Actualizar();
                int idUsuario=u.getId();
                request.getSession().setAttribute("scope", scope);
                request.getSession().setAttribute("idUsuario", idUsuario);
                request.getSession().setAttribute("token", token);
                response.sendRedirect("index.jsp");
            //
        } catch (JSONException ex) {
            Logger.getLogger(ObtenerToken.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
