package uoc.facturaweb.trustedx;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import org.apache.xerces.utils.Base64;

/**
 *
 * @author Juanjo
 */
public class SubeCertificado {
    public static void SubirCertif(byte [] xm2, String token){
        try {
            byte[] b64=Base64.encode(xm2);
            OkHttpClient client = new OkHttpClient();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, "{\r\n    \"labels\" : [\"uoc\", \"student\"],\r\n  \"pkcs12\" : \" "+b64+" \",\r\n    \"password\" : \"trustedx\"\r\n}");
            Request request2 = new Request.Builder()
                    .url("https://uoc.safelayer.com:8082/trustedx-resources/esigp/v1/sign_identities/server/pki_x509/pkcs12")
                    .post(body)
                    .addHeader("Authorization", "Bearer "+token)
                    .addHeader("Content-Type", "application/json")
                    .addHeader("cache-control", "no-cache")
                    .addHeader("Postman-Token", "4a96ca5f-4586-4295-8807-4d5100008978")
                    .build();
            
            Response response2 = client.newCall(request2).execute();
        } catch (IOException ex) {
            Logger.getLogger(SubeCertificado.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
}
